#include <iostream>
#include <exception>
#include "SealKernel/Exception.h"

#define private public
#include "CoralBase/Attribute.h"
#include "CoralBase/AttributeSpecification.h"


int main( int, char** )
{
  try {
    coral::AttributeSpecification spec( "x", typeid(double) );
    coral::Attribute attribute( spec );
    attribute.data<double>() = 11.22;
    std::cout << attribute.specification().name() << " ("
              << attribute.specification().typeName() << ") : "
              << attribute.data<double>() << std::endl;
  }
  catch ( std::exception& e ) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
  catch ( ... ) {
    std::cerr << "Unknown exception ..." << std::endl;
    return 1;
  }
  std::cout << "[OVAL] : Test successful" << std::endl;
  return 0;
}
