#include <iostream>
#include <exception>
#include "CoralBase/TimeStamp.h"
#include "CoralBase/AttributeSpecification.h"

int main( int, char** )
{
  try {
    coral::TimeStamp thisMoment = coral::TimeStamp::now();
    std::cout << "Testing the \""
              << coral::AttributeSpecification::typeNameForType( thisMoment )
              << "\" type..." << std::endl;

    std::cout << "The moment was "
              << thisMoment.day() << "/"
              << thisMoment.month() << "/"
              << thisMoment.year() << " "
              << thisMoment.hour() << ":"
              << thisMoment.minute() << ":"
              << thisMoment.second() << "."
              << thisMoment.nanosecond() / 100000000 << std::endl;

    coral::TimeStamp anotherMoment( 1999, 12, 21, 12, 10, 30, 213331 );
    std::cout << "Danae was born on "
              << anotherMoment.day() << "/"
              << anotherMoment.month() << "/"
              << anotherMoment.year() << " at "
              << anotherMoment.hour() << ":"
              << anotherMoment.minute() << ":"
              << anotherMoment.second() << std::endl;
    std::cout << "Nanoseconds are " << anotherMoment.nanosecond() << std::endl;
  }
  catch ( std::exception& e ) {
    std::cerr << e.what() << std::endl;
    return 1;
  }
  catch ( ... ) {
    std::cerr << "Unknown exception ..." << std::endl;
    return 1;
  }
  std::cout << "[OVAL] : Test successful" << std::endl;
  return 0;
}
