// -*- C++ -*-
// $Id: TestBase.h,v 1.5 2006/12/08 15:40:57 rado Exp $
#ifndef TESTBASE_H
#define TESTBASE_H

#include "RelationalAccess/AccessMode.h"

#include "SealKernel/Context.h"

#include <string>

namespace coral
{
  class ISession;
  class IConnectionService;
  class ITypeConverter;
}

class TestBase
{
  public:
    // Constructor
    TestBase();

    // Destructor
    virtual ~TestBase();

    // The actual run method
    virtual void run() = 0;

  protected:
    // Returns a session object
    coral::ISession* connect( const std::string& connectionString,
                              const std::string& userName,
                              const std::string& password,
                              coral::AccessMode  mode=coral::ReadOnly );

    void disconnect();

    coral::ITypeConverter& typeConverter() const;
    
    // Returns CORAL connection service handle
    seal::IHandle<coral::IConnectionService> connectionService();

  private:
    seal::Handle<seal::Context> m_context;
};

#endif
