#ifndef LFCREPLICASERVICE_XMLAUTHENTICATIONFILEPARSER_H
#define LFCREPLICASERVICE_XMLAUTHENTICATIONFILEPARSER_H

#include "RelationalAccess/AccessMode.h"
#include <string>
#include <vector>
#include <map>

namespace seal {
  class Context;
}

namespace coral {

  class AuthenticationCredentialSet;

class XMLAuthenticationFileParser {
  public:
  XMLAuthenticationFileParser(seal::Context* context, const std::string& serviceCallerName);
  
  virtual ~XMLAuthenticationFileParser(){}

  // ownership of the DatabaseServiceDescription* objects is left to the caller
  bool parse(const std::string& inputFileName, std::map< std::string,AuthenticationCredentialSet* >& data);

  private:

  seal::Context* m_context;

  std::string m_serviceCallerName;
};
 
}

inline
coral::XMLAuthenticationFileParser::XMLAuthenticationFileParser(seal::Context* context, const std::string& serviceCallerName):
  m_context(context),m_serviceCallerName(serviceCallerName){}

#endif
