#ifndef LFCREPLICASERVICE_XMLLOOKUPFILEPARSER_H
#define LFCREPLICASERVICE_XMLLOOKUPFILEPARSER_H

#include "RelationalAccess/AccessMode.h"
#include <string>
#include <vector>
#include <map>

namespace seal {
  class Context;
}

namespace coral {

  class DatabaseServiceDescription;

class XMLLookupFileParser {
  public:
  XMLLookupFileParser(seal::Context* context, const std::string& serviceCallerName);
  
  virtual ~XMLLookupFileParser(){}

  // ownership of the DatabaseServiceDescription* objects is left to the caller
  bool parse(const std::string& inputFileName, std::map< std::string, std::vector< DatabaseServiceDescription* > >& data);

  private:

  seal::Context* m_context;

  std::string m_serviceCallerName;
};
 
}

inline
coral::XMLLookupFileParser::XMLLookupFileParser(seal::Context* context, const std::string& serviceCallerName):
  m_context(context),m_serviceCallerName(serviceCallerName){}

#endif
