#include "DomainProperties.h"
#include "Domain.h"
#include "TypeConverter.h"

coral::MySQLAccess::DomainProperties::DomainProperties( coral::MySQLAccess::Domain* service )
  : m_service( service )
  , m_typeConverter( seal::Handle<seal::Component>( new seal::Component(0,"CORAL/mysql/empty") ) )
{
  // Make sure MySQL type converter is available
  this->m_typeConverter = m_service->localContext()->component<coral::MySQLAccess::TypeConverter>();
  
  if( !m_typeConverter )
    m_typeConverter = seal::Handle<seal::Component>( new coral::MySQLAccess::TypeConverter( this->service()->localContext() ) );
//     throw coral::TypeConverterException( "MySQLAccess", "Type converter not loaded", "MySQLAccess::SessionProperties::typeConverter" );
}

coral::MySQLAccess::DomainProperties::~DomainProperties()
{
}

seal::Service* coral::MySQLAccess::DomainProperties::service() const
{
  return dynamic_cast<seal::Service*>(m_service);
}

coral::ITypeConverter& coral::MySQLAccess::DomainProperties::typeConverter() const
{
  return *(this->m_typeConverter);
}
