// -*- C++ -*-
// $Id: DomainProperties.h,v 1.3 2006/12/06 20:16:29 rado Exp $
#ifndef MYSQLACCESS_MYSQLDOMAIN_PROPERTIES_H
#define MYSQLACCESS_MYSQLDOMAIN_PROPERTIES_H 1

#include "SealKernel/Service.h"

#include <string>

namespace seal
{
  class Service;
}

namespace coral
{
  class ITypeConverter;
  
  namespace MySQLAccess
  {
    class Domain;
    class TypeConverter;
    
    /**
     * A simple class holding the global domain properties
     */

    class DomainProperties
    {
      public:
        /// Constructor
        explicit DomainProperties( coral::MySQLAccess::Domain* service );
        
        /// Destructor
        ~DomainProperties();

        /// Returns the pointer to the service
        seal::Service* service() const;

        /// The type converter
        coral::ITypeConverter& typeConverter() const;
        
      private:
        /// The pointer to the service
        coral::MySQLAccess::Domain*          m_service;
        /// The type converter
        seal::IHandle<coral::ITypeConverter> m_typeConverter;
    };
  }
}

#endif // MYSQLACCESS_MYSQLDOMAIN_PROPERTIES_H
