#ifndef TESTBASE_H
#define TESTBASE_H

#include "SealKernel/Context.h"

#include "RelationalAccess/AccessMode.h"

#include <string>

namespace coral
{
  class ISession;
}

class TestBase
{
public:
  // Constructor
  TestBase( seal::Context* ctx=0 );

  // Destructor
  virtual ~TestBase();

  // The actual run method
  virtual void run() = 0;

protected:
  // Returns a session object
  coral::ISession* connect( const std::string& connectionString, const std::string& userName, const std::string& password, coral::AccessMode );

private:
  seal::Handle<seal::Context> m_context;
};

#endif
