#ifndef TESTBASE_H
#define TESTBASE_H

#include <string>
#include "SealKernel/Context.h"
#include "SealKernel/IMessageService.h"

namespace coral {
  class IConnection;
  class ISession;
}

class TestBase
{
public:
  // Constructor
  TestBase();

  // Destructor
  virtual ~TestBase();

  // The actual run method
  virtual void run() = 0;

  // Loads the message service if necessary and sets the verbosity level
  void setVerbosityLevel( seal::Msg::Level level );

protected:

  // Returns a session object
  coral::ISession* connect( const std::string& connectionString,
                            const std::string& userName,
                            const std::string& password );

private:
  // The local context
  seal::Handle<seal::Context> m_context;

  // The connection object
  coral::IConnection*         m_connection;
};

#endif
