#ifndef SQLITEACCESS_DOMAIN_PROPERTIES_H
#define SQLITEACCESS_DOMAIN_PROPERTIES_H

#include <string>

namespace seal {
  class Service;
}

namespace coral {

  namespace SQLiteAccess {

    /**
     * A simple class holding the global domain properties
     */

    class DomainProperties {
    public:
      /// Constructor
      explicit DomainProperties( seal::Service* service );

      /// Destructor
      ~DomainProperties();

      /// Returns the pointer to the service
      seal::Service* service() const;

    private:
      /// The pointer to the service
      seal::Service*       m_service;
    };
  }
}


inline seal::Service*
coral::SQLiteAccess::DomainProperties::service() const
{
  return m_service;
}

#endif
