#ifndef SCHEMA_DEFINITION_H
#define SCHEMA_DEFINITION_H

#include "TestBase.h"
#include <string>

namespace coral {
  class IRelationalDomain;
  class IConnection;
  class ITableDescription;
  class IView;
}

class SchemaDefinition : public TestBase
{
public:
  SchemaDefinition( coral::IRelationalDomain& domain,
                    const std::string& connectionString,
                    coral::IAuthenticationService& authenticationService );

  ~SchemaDefinition();

  bool createSchema();

  bool readSchema();

private:
  void printTableInfo( const coral::ITableDescription& description ) const;
  void printViewInfo( const coral::IView& view ) const;

  coral::IConnection*       m_connection;
  std::string               m_schemaName;
};

#endif
