#ifndef INCLUDE_TESTAPP_H
#define INCLUDE_TESTAPP_H

#include <string>

#include "SealKernel/Context.h"

namespace coral {
  class IRelationalDomain;
}

class TestApp
{
public:
  // Constructor
  TestApp( const std::string& writerConnectionString,
           const std::string& readerConnectionString,
           const std::string& readerWorkingSchema );

  // Destructor
  ~TestApp();

  // run method
  void run();

private:
  // Loads the basic services
  void loadServices();

  // Returns a reference to the domain object for a given connection
  coral::IRelationalDomain& domain( const std::string& connectionString );

private:
  // The application context
  seal::Handle<seal::Context> m_context;
  // The writer connection string
  std::string                 m_writerConnectionString;
  // The reader connection string
  std::string                 m_readerConnectionString;
  // The reader working schema
  std::string                 m_readerWorkingSchema;
};

#endif
