#include "Connection.h"
#include "RelationalAccess/IConnectionServiceConfiguration.h"
#include <stdexcept>
#include "RelationalAccess/ISession.h"
#include "RelationalAccess/ITransaction.h"
#include "SealKernel/Context.h"
#include <stdexcept>

Connection::Connection()
{
    
  m_context = new seal::Context ;

  seal::PluginManager* pm = seal::PluginManager::get();
  pm->initialise();
  seal::Handle<seal::ComponentLoader> loader = new seal::ComponentLoader( m_context.get() );
  loader->load("CORAL/Services/ConnectionService");
  seal::IHandle<coral::IConnectionService> iHandle =
  m_context->query<coral::IConnectionService>( "CORAL/Services/ConnectionService" );

  if ( ! iHandle ) 
    throw std::runtime_error( "can not find ConnectionService" );
  else
  {
     coral::IConnectionServiceConfiguration& config = iHandle->configuration();
     config.setConnectionRetrialPeriod(2);
     config.setConnectionRetrialTimeOut(20);        
  }
 
}

Connection::~Connection()
{
}

coral::ISessionProxy* Connection::getSessionProxy( const std::string& ConnectionName, coral::AccessMode mode)
{
  seal::IHandle<coral::IConnectionService> iHandle =
  m_context->query<coral::IConnectionService>( "CORAL/Services/ConnectionService" );

  if ( ! iHandle )
  { 
    throw std::runtime_error( "Could not locate the connection service" );
  }	  
  else
  {
    coral::ISessionProxy *proxy = iHandle->connect(ConnectionName,mode );
    return proxy;
  }

}  
