#ifndef INCLUDE_TESTAPP_H
#define INCLUDE_TESTAPP_H

#include <string>

#include "SealKernel/Context.h"

namespace coral {
  class IRelationalDomain;
}

class TestApp
{
public:
  // Constructor
  explicit TestApp( const std::string& connectionString );

  // Destructor
  ~TestApp();

  // run method
  void run();

private:
  // Loads the basic services
  void loadServices();

  // Returns a reference to the domain object for a given connection
  coral::IRelationalDomain& domain( const std::string& connectionString );

  /// The test functions
  void writeData();
  void readData();
  void report();

private:
  // The application context
  seal::Handle<seal::Context> m_context;
  // The connection string
  std::string    m_connectionString;
};

#endif
