#ifndef INCLUDE_TESTAPP_H
#define INCLUDE_TESTAPP_H

#include "SealKernel/RefCounted.h"

#include <string>

namespace seal
{
  class Context;
}

namespace coral
{
  class ISessionProxy;
  class IConnectionService;
}

class TestApp
{
public:
  // Constructor
  explicit TestApp( const std::string& connectionString );

  // Destructor
  ~TestApp();

  // run method
  void run();

private:
  // Loads the basic services
  void loadServices();

  // Returns a reference to the domain object for a given connection
  coral::ISessionProxy* sessionProxy( const std::string& connectionString );

  /// The test functions
  void writeData();
  void readData();
  void report() const;

private:
  // The application context
  seal::Handle<seal::Context>              m_context;
  // The connection string
  std::string                              m_connectionString;
  // The connection service handle
  seal::IHandle<coral::IConnectionService> m_conSvc;
};

#endif
