#!/bin/bash
#
# Sets the requiered variables and starts a client with given parameter
#
# Need 3 parameters : the report period, the node hostname and the log files directory
if [[ $# != 3 ]];
then echo "Usage: runFrontierClient.sh reportPeriod hostName logFilesDir";
exit -1;
fi

#############################
### Stress test variables ###
#############################

export TEST_HOME=/afs/cern.ch/user/l/lramos/work/perf
export CORAL_HOME=$TEST_HOME/../coral_scram

export TEST_LOG=$STRESS_HOME/logs
export TEST_EXE=unitTest_FrontierAccess_CoralPerfClient

#############################
####### LCG variables #######
#############################

export LCG_BASE=/afs/cern.ch/sw/lcg
export LCGSPI_BASE=${LCG_BASE}/app/spi
export PATH=${PATH}:${LCGSPI_BASE}/scram
export SCRAM_ARCH=slc3_ia32_gcc323_dbg

cd $CORAL_HOME
eval `scram runtime -sh`

export LD_LIBRARY_PATH=/afs/cern.ch/user/l/lramos/work/perf/lib:/afs/cern.ch/user/l/lramos/work/coral_scram/slc3_ia32_gcc323_dbg/lib:/usr/lib:/usr/lib64:/usr/lib64:/user/X11R6/lib64:/afs/cern.ch/sw/lcg/external/uuid/1.38/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/Boost/1.33.1/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/mysql/5.0.18/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/oracle/10.2.0.2/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/sqlite/3.3.5/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/Python/2.4.2/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/XercesC/2.7.0/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/lfc/1.5.8/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/CppUnit/1.10.2_p2/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/expat/1.95.8/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/pcre/4.4/slc3_ia32_gcc323/lib:/afs/cern.ch/sw/lcg/external/vdt/1.2.3_globusrls215b/slc3_ia32_gcc323/globus/lib:/afs/cern.ch/sw/lcg/external/../app/releases/SEAL/SEAL_1_9_1/slc3_ia32_gcc323_dbg/lib:/afs/cern.ch/user/l/lramos/work/coral_scram/slc3_ia32_gcc323_dbg/lib:/afs/cern.ch/user/l/lramos/work/coral_scram/slc3_ia32_gcc323_dbg/lib:/afs/cern.ch/user/l/lramos/work/coral_scram/slc3_ia32_gcc323_dbg/tests/lib:/afs/cern.ch/user/l/lramos/work/coral_scram/slc3_ia32_gcc323_dbg/tests/lib:/afs/cern.ch/sw/lcg/external/Python/2.3.4/slc3_ia32_gcc323/lib:/afs/cern.ch/project/oracle/@sys/prod/lib

# coral_log_level -> E or D ==>> HARDCODED in test code, check TestBase.cpp
export CORAL_OUTMSG_LEVEL=E;

#############################
#### Frontier variables  ####
#############################

# frontier log level -> debug, error or nolog
export FRONTIER_LOG_LEVEL=error

# frt_zip_level -> 0 or 1 to 9
export CORAL_WEBCACHE_ZIP_LEVEL=5

# frt force cache refresh
export CORAL_FRONTIER_RELOAD=0

#############################
##### Client parameters #####
#############################

# Connection string (as defined in etc/dblookup.xml)
connStr=/dbdev/Oracle

# Query list file
queryListFileName=queryList.xml

# Report period
reportPeriod=$1

# Output Frontier client values
showFrtCltMetrics=0

#############################
####### Client start ########
#############################
host=$2
id=`ls -1 $3/log_$host*.log 2>/dev/null|wc -l|awk '{ print $1 }'`
log_file=$3/log_$host-$id

cd $TEST_HOME/bin
$TEST_EXE $connStr $queryListFileName $reportPeriod $showFrtCltMetrics >$log_file.log 2>$log_file.err &

# echo $TEST_EXE $connStr $queryListFileName $reportPeriod $showFrtCltMetrics
# echo $log_file.log $log_file.err
