# this script should be run in ..../tmp

# Setup environment
setenv LCG_BASE /afs/cern.ch/sw/lcg
setenv LCGSPI_BASE $LCG_BASE/app/spi
setenv PATH $PATH:$LCGSPI_BASE/scram
setenv SCRAM_ARCH slc3_ia32_gcc323_dbg

# check out CORAL
setenv CVSROOT :kserver:lramos@coral.cvs.cern.ch:/cvs/coral

# this script should be run in ..../tmp
export INST_DIR=$PWD/..

# Scram CORAL (use last version of CORAL)
scram project CORAL CORAL_1_6_3a
cd CORAL_1_6_3a
scram setup

# check out FrontierAccess (the perf test c++ runs as a FrontierAccess unit test)
cd src

# outside CERN run
cvs co -r FrontierAccess-1-4-1 FrontierAccess
if [ $? != 0 ]; then
	# fails because you are outside CERN
	klog.krb -c CERN.CH
	cvs co FrontierAccess
	# can't use CVS use tar file
	if [ $? != 0 ]; then
		cp -R $INST_DIR/lib/FrontierAccess .
	fi
fi

cd FrontierAccess
scram setup

cp -R $INST_DIR/src/CoralPerfClient tests/

# updated build file with XML dependencies (used to read queryList.xml)
cp $INST_DIR/etc/FrontierAccess_BuildFile BuildFile

cd tests
scram build CoralPerfClient

cd CoralPerfClient
eval `scram runtime -sh`
hash -r

cd $INST_DIR/etc
ln -s $INST_DIR/tmp/CORAL_1_6_3a/src/FrontierAccess/tests/CoralPerfClient/queryList.xml
ln -s $INST_DIR/tmp/CORAL_1_6_3a/src/FrontierAccess/tests/CoralPerfClient/authentication.xml
ln -s $INST_DIR/tmp/CORAL_1_6_3a/src/FrontierAccess/tests/CoralPerfClient/dblookup.xml
