#######################################################################
# Makefile for Unit testing of a Package                              # 
#######################################################################

THEPACKAGENAME=$(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/parent_dir_name.py $(dir $(ClassDir))` )
THETESTNAME=$(patsubst src/$(THEPACKAGENAME)/tests/%,%, $(ClassDir))
THEEXEDIR=$(LOCALTOP)/$(SCRAM_ARCH)/tests/bin

# Find the correct path for the libraries
LIBDIR += $(LOCALTOP)/$(SCRAM_ARCH)/lib
ifneq ($(RELEASETOP),$(LOCALTOP))
LIBDIR +=$(RELEASETOP)/$(SCRAM_ARCH)/lib
endif

# The application
THEEXECUTABLE=$(THEEXEDIR)/unitTest_$(THEPACKAGENAME)_$(THETESTNAME)$(EXESUF)

# These classes and the common classes
INCLUDE += $(dir $(LOCALTOP)/$(ClassDir))/Common
FILESCPP += $(wildcard $(LOCALTOP)/$(ClassDir)/*.$(CPPEXT) ) $(wildcard $(LOCALTOP)/$(dir $(ClassDir))/Common/*.$(CPPEXT))
FILESOBJ := $(patsubst $(LOCALTOP)%.$(CPPEXT), $(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(OBJEXT), $(FILESCPP) )
FILESDEP := $(patsubst %.$(OBJEXT), %.$(DEPEXT), $(FILESOBJ) )

ifneq ($(FILESDEP),)
-include $(FILESDEP)
endif

$(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(DEPEXT): $(LOCALTOP)%.$(CPPEXT)
	@echo "Building the dependencies for $<"
	@$(MKDIR) $(dir $@)
	@$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/find_dependencies.py $< $@ $(OBJEXT) $(INCLUDE)

# The main rule
PackageTest: $(THEEXECUTABLE)
	@echo "Built unit test $(THETESTNAME) for package $(THEPACKAGENAME)" 


# The rule for building the library from the objects
ifeq ($(FILESOBJ),)
$(THEEXECUTABLE):
else
$(THEEXECUTABLE): $(FILESOBJ)
	@$(MKDIR) $(dir $@)
	$(BUILDEXE)
endif

# The rule for building the objects from the sources
$(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(OBJEXT): $(LOCALTOP)%.$(CPPEXT)
	@$(MKDIR) $(dir $@)
	$(COMPILE)
