# Test Library Context Defaults

# Extracting the library name
libraryName=$(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/parent_dir_name.py $(ClassDir)` )
lib := $(patsubst $(libraryName),,$(lib))

# Find the correct path for the libraries
LIBDIR += $(LOCALTOP)/$(SCRAM_ARCH)/lib $(LOCALTOP)/$(SCRAM_ARCH)/tests/lib
ifneq ($(RELEASETOP),$(LOCALTOP))
LIBDIR +=$(RELEASETOP)/$(SCRAM_ARCH)/lib $(RELEASETOP)/$(SCRAM_ARCH)/tests/lib
endif

THELIBDIR=$(LOCALTOP)/$(SCRAM_ARCH)/tests/lib
THELIBRARY=$(THELIBDIR)/$(LIBPRE)$(libraryName).$(LIBEXT)

ifeq ($(PLUGIN_MODULE),$(libraryName))
  PLUGIN_MODULE_RULE := plugin_module_rule

$(PLUGIN_MODULE_RULE): $(THELIBRARY)
	@$(MKDIR) $(THELIBDIR)/modules
	@echo 'module $(LIBPRE)$(libraryName).$(LIBEXT)' > $(THELIBDIR)/modules/$(libraryName).reg
else
  PLUGIN_MODULE_RULE :=
endif

# Main rule
TestLib: preTestLib $(THELIBRARY) postTestLib $(PLUGIN_MODULE_RULE)
	@echo "Done."


# Reset the source files to be used
FILESCPP :=

# Check for preTestLib step
ifeq ($(findstring preTestLib.mk, $(notdir $(wildcard $(LOCALTOP)/src/Tests/Libraries/$(libraryName)/build/*.mk))),)
preTestLib:
	@echo "No preTestLib step for $(libraryName)"

else
include $(LOCALTOP)/src/Tests/Libraries/$(libraryName)/build/preTestLib.mk
endif

# The source and the object files
FILESCPP += $(wildcard $(LOCALTOP)/$(ClassDir)/*.$(CPPEXT) )
FILESOBJ := $(patsubst $(LOCALTOP)%.$(CPPEXT), $(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(OBJEXT), $(FILESCPP) )
FILESDEP := $(patsubst %.$(OBJEXT), %.$(DEPEXT), $(FILESOBJ) )

ifneq ($(FILESDEP),)
-include $(FILESDEP)
endif

# The rule for building the dependencies
$(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(DEPEXT): $(LOCALTOP)%.$(CPPEXT)
	@echo "Building the dependencies for $<"
	@$(MKDIR) $(dir $@)
	@$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/find_dependencies.py $< $@ $(OBJEXT) $(INCLUDE)

# The rule for building the library
ifeq ($(FILESOBJ),)
$(THELIBRARY):
else
$(THELIBRARY): $(FILESOBJ)
	@$(MKDIR) $(THELIBDIR)
	$(BUILDLIB)
	@echo "Built test library $(THELIBRARY)"
endif

# The rule for building the objects from the sources
$(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(OBJEXT): $(LOCALTOP)%.$(CPPEXT)
	@$(MKDIR) $(dir $@)
	$(COMPILE)


# Finally check for postTestLib check
ifeq ($(findstring postTestLib.mk, $(notdir $(wildcard $(LOCALTOP)/src/Tests/Libraries/$(libraryName)/build/*.mk))),)
postTestLib:
	@echo "No postTestLib step for $(libraryName)"

else
include $(LOCALTOP)/src/Tests/Libraries/$(libraryName)/build/postTestLib.mk
endif
