# Test executable Context Defaults

# Extracting the application name
applicationName=$(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/parent_dir_name.py $(ClassDir)` )

# The executable
THEEXEDIR=$(LOCALTOP)/$(SCRAM_ARCH)/tests/bin
THEEXECUTABLE=$(THEEXEDIR)/test_$(applicationName)$(EXESUF)

# Find the correct path for the libraries
LIBDIR += $(LOCALTOP)/$(SCRAM_ARCH)/lib $(LOCALTOP)/$(SCRAM_ARCH)/tests/lib
ifneq ($(RELEASETOP),$(LOCALTOP))
LIBDIR +=$(RELEASETOP)/$(SCRAM_ARCH)/lib $(RELEASETOP)/$(SCRAM_ARCH)/tests/lib
endif

# Main rule
Test: preTest $(THEEXECUTABLE) postTest
	@echo "Done"

# Reset the source files to be used
FILESCPP :=

# Check for preTest step
ifeq ($(findstring preTest.mk, $(notdir $(wildcard $(LOCALTOP)/src/Tests/$(applicationName)/build/*.mk))),)
preTest:
	@echo "No preTest step for $(applicationName)"

else
include $(LOCALTOP)/src/Tests/$(applicationName)/build/preTest.mk
endif

# The source and the object files
FILESCPP += $(wildcard $(LOCALTOP)/$(ClassDir)/*.$(CPPEXT) )
FILESOBJ := $(patsubst $(LOCALTOP)%.$(CPPEXT), $(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(OBJEXT), $(FILESCPP) )
FILESDEP := $(patsubst %.$(OBJEXT), %.$(DEPEXT), $(FILESOBJ) )

ifneq ($(FILESDEP),)
-include $(FILESDEP)
endif

# The rule for building the dependencies
$(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(DEPEXT): $(LOCALTOP)%.$(CPPEXT)
	@echo "Building the dependencies for $<"
	@$(MKDIR) $(dir $@)
	@$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/find_dependencies.py $< $@ $(OBJEXT) $(INCLUDE)

# The rule for building the executable
ifeq ($(FILESOBJ),)
$(THEEXECUTABLE):
else
$(THEEXECUTABLE): $(FILESOBJ)
	@$(MKDIR) $(THEEXEDIR)
	$(BUILDEXE)
endif

# The rule for building the objects from the sources
$(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(OBJEXT): $(LOCALTOP)%.$(CPPEXT)
	@$(MKDIR) $(dir $@)
	$(COMPILE)

# Check for postTest step
ifeq ($(findstring postTest.mk, $(notdir $(wildcard $(LOCALTOP)/src/Tests/$(applicationName)/build/*.mk))),)
postTest:
	@echo "No postTest step for $(applicationName)"

else
include $(LOCALTOP)/src/Tests/$(applicationName)/build/postTest.mk
endif
