#!/usr/bin/env python

import sys
import os
import os.path
import string
import shutil

# Excluded file and directory names for the copying
excludedNames= ( 'CVS', 'BuildFile')

# Main recursive function which copies files
# and directories
def copyFilesRecursively( sourceDir, targetDir ):
    if not os.path.exists( sourceDir ) :
        raise "Directory " + sourceDir + " does not exist"
    if not os.path.exists( targetDir ) :
        raise "Directory " + targetDir + " does not exist"
    filesAndDirs = os.listdir( sourceDir )
    for file in filesAndDirs:
        if file not in excludedNames:
            sourceFile = os.path.join( sourceDir, file )
            targetFile = os.path.join( targetDir, file )
            if os.path.isfile( sourceFile ):
                if os.path.exists( targetFile ):
                    os.remove( targetFile )
                shutil.copyfile( sourceFile, targetFile )
                shutil.copymode( sourceFile, targetFile )
            else:
                if not os.path.exists( targetFile ):
                    os.mkdir( targetFile )
                copyFilesRecursively( sourceFile, targetFile )
    return 1


# Main script starts here.

# Check the number of arguments
if len(sys.argv) < 3:
    raise "Syntax : " + sys.argv[0] + " sourceDir targetDir"

# Perform the copy
copyFilesRecursively( sys.argv[1], sys.argv[2] )

