# Extracting the library name
libraryName = $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/parent_dir_name.py $(ClassDir)` )
lib := $(patsubst lcg_$(libraryName),,$(lib))

# Find the correct path for the libraries
LIBDIR += $(LOCALTOP)/$(SCRAM_ARCH)/lib
ifneq ($(RELEASETOP),$(LOCALTOP))
LIBDIR +=$(RELEASETOP)/$(SCRAM_ARCH)/lib
endif

LIBPREFIX := $(LIBPRE)lcg_

# The library
THELIBDIR := $(LOCALTOP)/$(SCRAM_ARCH)/lib
THELIBRARY := $(THELIBDIR)/$(LIBPREFIX)$(libraryName).$(LIBEXT)

ifeq ($(PLUGIN_MODULE),$(libraryName))
  PLUGIN_MODULE_RULE := plugin_module_rule

$(PLUGIN_MODULE_RULE): $(THELIBRARY)
	@$(MKDIR) $(THELIBDIR)/modules
	@echo 'module $(LIBPREFIX)$(libraryName).$(LIBEXT)' > $(THELIBDIR)/modules/lcg_$(libraryName).reg
else
  PLUGIN_MODULE_RULE :=
endif

# Main rule
library : prelib $(THELIBRARY) postlib $(PLUGIN_MODULE_RULE)
	@echo "Done"

# Reset the source files to be used
FILESCPP :=

# Check for pretest and posttest steps
ifeq ($(findstring prelib.mk, $(notdir $(wildcard $(LOCALTOP)/src/$(libraryName)/build/*.mk))),)
prelib:
	@echo "No prelib step for $(libraryName)"

else
include $(LOCALTOP)/src/$(libraryName)/build/prelib.mk
endif

# The source and the object files
FILESCPP += $(wildcard $(LOCALTOP)/$(ClassDir)/*.$(CPPEXT) )
FILESOBJ := $(patsubst $(LOCALTOP)%.$(CPPEXT), $(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(OBJEXT), $(FILESCPP) )
FILESDEP := $(patsubst %.$(OBJEXT), %.$(DEPEXT), $(FILESOBJ) )

ifneq ($(PYTHON_MODULE),)
 FILESOBJ := $(filter-out $(LOCALTOP)/tmp/$(SCRAM_ARCH)/$(ClassDir)/$(PYTHON_MODULE).$(OBJEXT), $(FILESOBJ))
endif

ifneq ($(FILESDEP),)
-include $(FILESDEP)
endif

$(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(DEPEXT): $(LOCALTOP)%.$(CPPEXT)
	@echo "Building the dependencies for $<"
	@$(MKDIR) $(dir $@)
	@$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/find_dependencies.py $< $@ $(OBJEXT) $(INCLUDE)

# The rule for building the library
ifeq ($(FILESOBJ),)
$(THELIBRARY):
else
$(THELIBRARY): $(FILESOBJ)
	@$(MKDIR) $(THELIBDIR)
	$(BUILDLIB)
	@echo "Built library $(THELIBRARY)"
endif

# The rule for building the objects from the sources
$(LOCALTOP)/tmp/$(SCRAM_ARCH)%.$(OBJEXT): $(LOCALTOP)%.$(CPPEXT)
	@$(MKDIR) $(dir $@)
	$(COMPILE)

ifeq ($(findstring postlib.mk, $(notdir $(wildcard $(LOCALTOP)/src/$(libraryName)/build/*.mk))),)
postlib:
	@echo "No postlib step for $(libraryName)"

else
include $(LOCALTOP)/src/$(libraryName)/build/postlib.mk
endif
