#!/usr/bin/env python

import sys
import os
import os.path
import string


# Lists the subdirectories of a given directory
def listSubDirs( curdir ):
    excludedDirNames = ( 'CVS', 'cmt' )
    dirContents = os.listdir( curdir )
    dirsToProcess = []
    for content in dirContents :
        if os.path.isdir( os.path.join( curdir, content ) ) :
            if content not in excludedDirNames :
                dirsToProcess.append( content )
    return dirsToProcess


########### Main Script starts here ###################

try:
    # Check the number of arguments
    if len(sys.argv) < 3:
        errorString = "Syntax : " + os.path.split( sys.argv[0] )[1] + " localTop classPathDirectory"
        raise Exception, errorString

    # Find the subdirectories
    localTop = sys.argv[1]
    classDir = sys.argv[2]
    curdir = os.path.join( localTop, classDir )
    dirsToProcess = listSubDirs( curdir )

    # The supported rules are src, dict [tests, utilities, scripts]
    orderedDirs = []
    if 'src' in dirsToProcess:
        orderedDirs.append( 'src' )
    if 'dict' in dirsToProcess:
        orderedDirs.append( 'dict' )

    # Check if it is a core library package for the additional rules
    if os.path.split( classDir )[0] == 'src':
        if 'tests' in dirsToProcess:
            orderedDirs.append( 'tests' )
        if 'utilities' in dirsToProcess:
            orderedDirs.append( 'utilities' )
        if 'scripts' in dirsToProcess:
            orderedDirs.append( 'scripts' )
        if 'python' in dirsToProcess:
            orderedDirs.append( 'python' )

    # Print the directories to process
    for iDir in orderedDirs:
        sys.stdout.write( iDir + ' ' )
    sys.stdout.write( '\n' )

except Exception, e:
    sys.stderr.write( str(e) + '\n' )

