#!/usr/bin/env python

import sys
from unixToWinPath import unixToWinPath

from os import environ, system, remove, path, popen
from tempfile import mktemp
import re

def vcdir():
    tmpFile = mktemp()
    system("regedit /E %s 'HKEY_LOCAL_MACHINE\\Software\\Microsoft\\VisualStudio\\7.1'"%tmpFile)
    reg = open(tmpFile).read()
    remove(tmpFile)
    m = re.search('"InstallDir"="([^"]*)"',reg)
    if m:
        instPath = m.group(1).replace('\\\\','/')
        pathToVC = path.join( path.split(path.split(instPath)[0])[0] , 'Vc7' )
    else:
        pathToVC = 'C:/Program Files/Microsoft Visual Studio .NET 2003/Vc7'
    return popen("winepath \"%s\""%pathToVC).read().strip()

def includeStatement():
    vctop = vcdir()
    sysincludes = [ path.join( vctop, 'include' ), path.join( vctop, 'PlatformSDK', 'Include' ) ]
    winIncludes = unixToWinPath( sysincludes )
    res = '/I' + winIncludes[0] + ' /I' + winIncludes[1]
    return res

def includeDictStatement():
    vctop = vcdir()
    sysincludes = [ path.join( vctop, 'include' ), path.join( vctop, 'PlatformSDK', 'Include' ) ]
    # BUG FIX 1: Need Unix-like path instead of Windows-like path
    #winIncludes = unixToWinPath( sysincludes )
    winIncludes = sysincludes
    # BUG FIX 2: Even with holes in the filenames, remove the quotes...?!?
    #res = '-I"' + winIncludes[0] + '" -I"' + winIncludes[1] + '"'
    res = '-I' + winIncludes[0] + ' -I' + winIncludes[1]
    # Marco: I do not understand this second bug-fix I would have used (which is good with wine):
    # res = '-I"\\"' + winIncludes[0] + '\\"" -I"\\"' + winIncludes[1] + '\\""'
    return res

def libdirStatement():
    vctop = vcdir()
    syslibdirs = [ path.join( vctop, 'lib' ), path.join( vctop, 'PlatformSDK', 'Lib' ) ]
    winlibdirs = unixToWinPath( syslibdirs )
    res = '/LIBPATH:' + winlibdirs[0] + ' /LIBPATH:' + winlibdirs[1]
    return res

if __name__ == "__main__":
    if len(sys.argv) < 2:
        print vcdir()
    else:
        if sys.argv[1] == '-i':
            print includeStatement()
        elif sys.argv[1] == '-d':
            print includeDictStatement()
        elif sys.argv[1] == '-l':
            print libdirStatement()
        else:
            print vcdir()


