GPPEXE := $(shell echo `$(SCRAM) t t gcc3 CXX`)
PYTHONEXE := python
MKDIR := mkdir -p
LIBPRE := lib
LIBEXT := so
OBJEXT := o
EXESUF :=
CPPEXT := cpp
DEPEXT := d
HEADEXT:= h
THEINPUT = $<
DEFINEFLAGS = -D_GNU_SOURCE -DGNU_SOURCE
INCLUDEFLAGS = $(patsubst %,-I%,$(INCLUDEDIRS))
COMPILERFLAGS += -pipe -ansi -pedantic-errors
COMPILERFLAGS += -W -Wall -Woverloaded-virtual -Wno-long-long -Wnon-virtual-dtor -Wwrite-strings -Wpointer-arith -Wno-non-template-friend -Wimplicit -Wreturn-type -Wunused -Wparentheses -Wuninitialized -Wctor-dtor-privacy
COMPILERFLAGS += -pthread -fmessage-length=0 -ftemplate-depth-300 -fPIC
COMPILERFLAGS += -O2
FINALCOMPILERFLAGS = $(INCLUDEFLAGS) $(DEFINEFLAGS) $(filter-out $(EXCLUDEDCOMPILERFLAGS),$(COMPILERFLAGS))
LINKERFLAGS = $(patsubst %,-L%,$(LIBDIRS)) $(patsubst %,-l%,$(LIBS))
LINKERFLAGS += -Wl,-E -pthread
COMPILE = $(GPPEXE) -c $(FINALCOMPILERFLAGS) -o $@ $(THEINPUT)
BUILDLIB = $(GPPEXE) -o $@ -shared $(FILESOBJ) $(LINKERFLAGS)
BUILDPYLIB = $(GPPEXE) -o $@ -shared $< $(LINKERFLAGS) -llcg_$(libraryName)
BUILDEXE = $(GPPEXE) -o $@ $(FILESOBJ) $(LINKERFLAGS)
COMPILEANDBUILDEXE = $(GPPEXE) -o $@ $(FINALCOMPILERFLAGS) $(LINKERFLAGS) $(THEINPUT)
IMPORTPYTHONMODULE = python -c 'import $(PYTHON_MODULE)'
