#!/usr/bin/env python

from sys import argv
from os import environ, popen, path
from string import join

def unixToWinPath( unixPaths, nativeSep = True ):
    res = []
    winPaths = []
    cmdline = "%s "
    for p in unixPaths:
        if ':' in p and (p.find("dosdevices/") < 0):
            tmp = p.split(':')
            all_dirs = ""
            for t in tmp:
                all_dirs += '"%s" '%(t.replace('"','\\"'))
            tmp = popen('winepath -l %s'%all_dirs).readlines()
            localres = ""
            for n in tmp:
                if localres:
                    localres += ';'
                localres += n.strip()
            winPaths.append(localres)
        else:
            cmdline += ' "%s"'%(p.replace('"','\\"'))
        
    winPaths += popen(cmdline%'winepath -l').readlines()
    for p in winPaths:
        if nativeSep:
            p = p.replace('\\','\\\\')
        else:
            p = p.replace('\\','/')
        res.append( p.strip().replace(' ','\\ ') )
    return res

if __name__ == "__main__":
    nativeSep = True
    # check option
    if len( argv ) > 1:
        if argv[1] == "-u" :
            nativeSep = False
            del argv[1]
        elif argv[1] == "-w" :
            nativeSep = True
            del argv[1]
    # convert paths
    if  len( argv ) > 1:
        paths = []
        res = unixToWinPath(argv[1:],nativeSep)
        print join(res,' ')
