PYTHONEXE := /usr/bin/python
WINE := wine
MKDIR := mkdir -p
LIBPRE :=
LIBEXT := dll
OBJEXT := obj
EXESUF := .exe
CPPEXT := cpp
DEPEXT := dep
HEADEXT:= h

TRANSFORMEDINCLUDEDIRS = $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/unixToWinPath.py $(INCLUDEDIRS)`)
TRANSFORMEDLIBDIRS = $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/unixToWinPath.py $(LIBDIRS)`)
TRANSFORMEDTARGET = $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/unixToWinPath.py $@`)
THEINPUT = $<
TRANSFORMEDINPUT = $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/unixToWinPath.py $(THEINPUT)`)

SYSTEMINCLUDE := $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/locateVcInstallation.py -i`)
SYSTEMINCLUDEDICT := $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/locateVcInstallation.py -d`)
SYSTEMLIB := $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/locateVcInstallation.py -l`)

COMPILE = $(WINE) cl.exe /nologo /c $(FINALCOMPILERFLAGS) /Fo$(TRANSFORMEDTARGET) $(TRANSFORMEDINPUT)

THE_ARCLIB = $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/unixToWinPath.py $(patsubst %.$(LIBEXT),%.arc,$@)`)
THE_DEFFILE = $(patsubst %.arc,%.def,$(THE_ARCLIB))
THE_UDEFFILE = $(patsubst %.$(LIBEXT),%.def,$@)
THE_EXPFILE = $(patsubst %.arc,%.exp,$(THE_ARCLIB))
THE_LIBFILE = $(patsubst %.arc,%.lib,$(THE_ARCLIB))
THE_DLLFILE = $(patsubst %.arc,%.$(LIBEXT),$(THE_ARCLIB))
THE_FILESOBJ = $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/unixToWinPath.py $(FILESOBJ)`)
THE_PYOBJFILE = $(shell echo `$(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/unixToWinPath.py $<`)
THE_PYLIB = $(LIBPREFIX)$(libraryName).lib

BUILDLIB = $(WINE) lib.exe /NOLOGO /MACHINE:X86 /OUT:$(THE_ARCLIB) $(THE_FILESOBJ); \
           $(WINE) dumpbin.exe /SYMBOLS $(THE_ARCLIB) > $(THE_UDEFFILE); \
           $(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/buildwindef.py $(THE_UDEFFILE); \
           $(WINE) lib.exe /NOLOGO /MACHINE:X86 /DEF:$(THE_DEFFILE) /OUT:$(THE_LIBFILE); \
           $(WINE) link.exe /NOLOGO /DLL /OUT:$(THE_DLLFILE) $(THE_EXPFILE) $(THE_ARCLIB) $(LINKERFLAGS)# Nothing else

BUILDPYLIB = $(WINE) link.exe /NOLOGO /DLL /OUT:$(THE_DLLFILE) $(THE_PYOBJFILE) $(LINKERFLAGS) $(THE_PYLIB)# Nothing else

BUILDEXE = $(WINE) link.exe /NOLOGO /OUT:$(TRANSFORMEDTARGET) /EXETYPE:DYNAMIC $(LINKERFLAGS) $(THE_FILESOBJ)
COMPILEANDBUILDEXE = $(WINE) cl.exe /nologo $(FINALCOMPILERFLAGS) $(TRANSFORMEDINPUT) /link /OUT:$(TRANSFORMEDTARGET) $(LINKERFLAGS)

INCLUDEFLAGS = $(patsubst %,/I%,$(TRANSFORMEDINCLUDEDIRS))
DEFINEFLAGS = /D_GNU_SOURCE /DGNU_SOURCE /DWIN32 /D_MBCS /D_WIN32 /D__WIN__ /D_WINDOWS /DSEAL_KERNEL_BUILD_ARCHIVE /D_DEBUG
COMPILERFLAGS = /W3 /WL /GR /GX /GF /GS /MD /Od /Z7
FINALCOMPILERFLAGS = $(INCLUDEFLAGS) $(SYSTEMINCLUDE) $(DEFINEFLAGS) $(filter-out $(EXCLUDEDCOMPILERFLAGS),$(COMPILERFLAGS))

LINKERFLAGS = /DEBUG /INCREMENTAL:NO $(patsubst %,/LIBPATH:%,$(TRANSFORMEDLIBDIRS)) $(SYSTEMLIB) $(patsubst %,%.lib,$(LIBS))
LINKERFLAGS += /nodefaultlib kernel32.lib user32.lib msvcprt.lib msvcrt.lib oldnames.lib

IMPORTPYTHONMODULE = $(PYTHONEXE) $(LOCALTOP)/$(projconfigdir)/winimportmodule.py $(LOCALTOP)/$(projconfigdir) $(PYTHON_MODULE)
